Fix build after addition of 'empty-cluster.data'
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Block \
61         htools/Ganeti/Block/Drbd \
62         htools/Ganeti/Confd \
63         htools/Ganeti/DataCollectors \
64         htools/Ganeti/HTools \
65         htools/Ganeti/HTools/Backend \
66         htools/Ganeti/HTools/Program \
67         htools/Ganeti/Query \
68         htest \
69         htest/Test \
70         htest/Test/Ganeti \
71         htest/Test/Ganeti/Block \
72         htest/Test/Ganeti/Block/Drbd \
73         htest/Test/Ganeti/Confd \
74         htest/Test/Ganeti/HTools \
75         htest/Test/Ganeti/HTools/Backend \
76         htest/Test/Ganeti/Query
77
78 DIRS = \
79         $(HTOOLS_DIRS) \
80         autotools \
81         daemons \
82         devel \
83         doc \
84         doc/examples \
85         doc/examples/gnt-debug \
86         doc/examples/hooks \
87         htest/data \
88         htest/data/rapi \
89         htest/shelltests \
90         lib \
91         lib/build \
92         lib/client \
93         lib/confd \
94         lib/http \
95         lib/hypervisor \
96         lib/impexpd \
97         lib/masterd \
98         lib/rapi \
99         lib/server \
100         lib/tools \
101         lib/utils \
102         lib/watcher \
103         man \
104         qa \
105         test \
106         test/data \
107         test/data/ovfdata \
108         test/data/ovfdata/other \
109         tools
110
111 ALL_APIDOC_HS_DIRS = \
112         $(APIDOC_HS_DIR) \
113         $(APIDOC_HS_DIR)/Ganeti \
114         $(APIDOC_HS_DIR)/Ganeti/Block \
115         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
116         $(APIDOC_HS_DIR)/Ganeti/Confd \
117         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
118         $(APIDOC_HS_DIR)/Ganeti/HTools \
119         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
120         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
121         $(APIDOC_HS_DIR)/Ganeti/Query
122
123 BUILDTIME_DIR_AUTOCREATE = \
124         scripts \
125         $(APIDOC_DIR) \
126         $(ALL_APIDOC_HS_DIRS) \
127         $(APIDOC_PY_DIR) \
128         $(COVERAGE_DIR) \
129         $(COVERAGE_HS_DIR) \
130         $(COVERAGE_PY_DIR) \
131         .hpc
132
133 BUILDTIME_DIRS = \
134         $(BUILDTIME_DIR_AUTOCREATE) \
135         doc/html
136
137 DIRCHECK_EXCLUDE = \
138         $(BUILDTIME_DIRS) \
139         ganeti-[0-9]*.[0-9]*.[0-9]* \
140         doc/html/_* \
141         autom4te.cache
142
143 # some helper vars
144 COVERAGE_DIR = doc/coverage
145 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
146 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
147 APIDOC_DIR = doc/api
148 APIDOC_PY_DIR = $(APIDOC_DIR)/py
149 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
150
151 MAINTAINERCLEANFILES = \
152         $(docpng) \
153         $(maninput) \
154         doc/install-quick.rst \
155         doc/news.rst \
156         doc/upgrade.rst \
157         vcs-version
158
159 maintainer-clean-local:
160         rm -rf $(BUILDTIME_DIRS)
161
162 CLEANFILES = \
163         $(addsuffix /*.py[co],$(DIRS)) \
164         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
165         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
166         $(PYTHON_BOOTSTRAP) \
167         epydoc.conf \
168         $(REPLACE_VARS_SED) \
169         $(SHELL_ENV_INIT) \
170         daemons/daemon-util \
171         daemons/ganeti-cleaner \
172         $(BUILT_EXAMPLES) \
173         doc/examples/bash_completion \
174         doc/examples/bash_completion-debug \
175         lib/_generated_rpc.py \
176         $(man_MANS) \
177         $(manhtml) \
178         tools/kvm-ifup \
179         tools/vcluster-setup \
180         stamp-directories \
181         stamp-srclinks \
182         $(nodist_pkgpython_PYTHON) \
183         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
184         $(HS_BUILT_TEST_HELPERS) \
185         htools/ganeti-confd \
186         .hpc/*.mix htools/*.tix htest/*.tix \
187         doc/hs-lint.html
188
189 GENERATED_FILES = \
190         $(built_base_sources) \
191         $(BUILT_PYTHON_SOURCES) \
192         $(PYTHON_BOOTSTRAP)
193
194 HTOOLS_GENERATED_FILES =
195 if WANT_HTOOLS
196 HTOOLS_GENERATED_FILES += $(HS_PROGS)
197 if ENABLE_CONFD
198 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
199 endif
200 endif
201
202 built_base_sources = \
203         stamp-directories \
204         stamp-srclinks
205
206 built_python_base_sources = \
207         lib/_autoconf.py \
208         lib/_vcsversion.py
209
210 BUILT_PYTHON_SOURCES = \
211         $(built_python_base_sources) \
212         lib/_generated_rpc.py
213
214 # Generating the RPC wrappers depends on many things, so make sure
215 # it's built at the end of the built sources
216 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
217
218 # these are all built from the underlying %.in sources
219 BUILT_EXAMPLES = \
220         doc/examples/ganeti-kvm-poweroff.initd \
221         doc/examples/ganeti.cron \
222         doc/examples/ganeti.initd \
223         doc/examples/ganeti-master-role.ocf \
224         doc/examples/ganeti-node-role.ocf \
225         doc/examples/gnt-config-backup \
226         doc/examples/hooks/ipsec
227
228 nodist_pkgpython_PYTHON = \
229         $(BUILT_PYTHON_SOURCES)
230
231 noinst_PYTHON = \
232         lib/build/__init__.py \
233         lib/build/shell_example_lexer.py \
234         lib/build/sphinx_ext.py
235
236 pkgpython_PYTHON = \
237         lib/__init__.py \
238         lib/asyncnotifier.py \
239         lib/backend.py \
240         lib/bdev.py \
241         lib/bootstrap.py \
242         lib/cli.py \
243         lib/cmdlib.py \
244         lib/compat.py \
245         lib/config.py \
246         lib/constants.py \
247         lib/daemon.py \
248         lib/errors.py \
249         lib/ht.py \
250         lib/jqueue.py \
251         lib/jstore.py \
252         lib/locking.py \
253         lib/luxi.py \
254         lib/mcpu.py \
255         lib/netutils.py \
256         lib/objects.py \
257         lib/objectutils.py \
258         lib/opcodes.py \
259         lib/ovf.py \
260         lib/pathutils.py \
261         lib/qlang.py \
262         lib/query.py \
263         lib/rpc.py \
264         lib/rpc_defs.py \
265         lib/runtime.py \
266         lib/serializer.py \
267         lib/ssconf.py \
268         lib/ssh.py \
269         lib/storage.py \
270         lib/uidpool.py \
271         lib/vcluster.py \
272         lib/network.py \
273         lib/workerpool.py
274
275 client_PYTHON = \
276         lib/client/__init__.py \
277         lib/client/gnt_backup.py \
278         lib/client/gnt_cluster.py \
279         lib/client/gnt_debug.py \
280         lib/client/gnt_group.py \
281         lib/client/gnt_instance.py \
282         lib/client/gnt_job.py \
283         lib/client/gnt_node.py \
284         lib/client/gnt_network.py \
285         lib/client/gnt_os.py
286
287 hypervisor_PYTHON = \
288         lib/hypervisor/__init__.py \
289         lib/hypervisor/hv_base.py \
290         lib/hypervisor/hv_chroot.py \
291         lib/hypervisor/hv_fake.py \
292         lib/hypervisor/hv_kvm.py \
293         lib/hypervisor/hv_lxc.py \
294         lib/hypervisor/hv_xen.py
295
296 rapi_PYTHON = \
297         lib/rapi/__init__.py \
298         lib/rapi/baserlib.py \
299         lib/rapi/client.py \
300         lib/rapi/client_utils.py \
301         lib/rapi/connector.py \
302         lib/rapi/rlib2.py \
303         lib/rapi/testutils.py
304
305 http_PYTHON = \
306         lib/http/__init__.py \
307         lib/http/auth.py \
308         lib/http/client.py \
309         lib/http/server.py
310
311 confd_PYTHON = \
312         lib/confd/__init__.py \
313         lib/confd/client.py
314
315 masterd_PYTHON = \
316         lib/masterd/__init__.py \
317         lib/masterd/iallocator.py \
318         lib/masterd/instance.py
319
320 impexpd_PYTHON = \
321         lib/impexpd/__init__.py
322
323 watcher_PYTHON = \
324         lib/watcher/__init__.py \
325         lib/watcher/nodemaint.py \
326         lib/watcher/state.py
327
328 server_PYTHON = \
329         lib/server/__init__.py \
330         lib/server/masterd.py \
331         lib/server/noded.py \
332         lib/server/rapi.py
333
334 pytools_PYTHON = \
335         lib/tools/__init__.py \
336         lib/tools/ensure_dirs.py \
337         lib/tools/node_cleanup.py \
338         lib/tools/node_daemon_setup.py \
339         lib/tools/prepare_node_join.py
340
341 utils_PYTHON = \
342         lib/utils/__init__.py \
343         lib/utils/algo.py \
344         lib/utils/filelock.py \
345         lib/utils/hash.py \
346         lib/utils/io.py \
347         lib/utils/log.py \
348         lib/utils/lvm.py \
349         lib/utils/mlock.py \
350         lib/utils/nodesetup.py \
351         lib/utils/process.py \
352         lib/utils/retry.py \
353         lib/utils/text.py \
354         lib/utils/wrapper.py \
355         lib/utils/x509.py
356
357 docrst = \
358         doc/admin.rst \
359         doc/cluster-merge.rst \
360         doc/design-2.0.rst \
361         doc/design-2.1.rst \
362         doc/design-2.2.rst \
363         doc/design-2.3.rst \
364         doc/design-2.4.rst \
365         doc/design-2.5.rst \
366         doc/design-2.6.rst \
367         doc/design-2.7.rst \
368         doc/design-autorepair.rst \
369         doc/design-bulk-create.rst \
370         doc/design-chained-jobs.rst \
371         doc/design-cpu-pinning.rst \
372         doc/design-draft.rst \
373         doc/design-htools-2.3.rst \
374         doc/design-http-server.rst \
375         doc/design-impexp2.rst \
376         doc/design-lu-generated-jobs.rst \
377         doc/design-linuxha.rst \
378         doc/design-multi-reloc.rst \
379         doc/design-network.rst \
380         doc/design-node-add.rst \
381         doc/design-oob.rst \
382         doc/design-ovf-support.rst \
383         doc/design-opportunistic-locking.rst \
384         doc/design-partitioned.rst \
385         doc/design-query-splitting.rst \
386         doc/design-query2.rst \
387         doc/design-remote-commands.rst \
388         doc/design-resource-model.rst \
389         doc/design-shared-storage.rst \
390         doc/design-monitoring-agent.rst \
391         doc/design-virtual-clusters.rst \
392         doc/design-x509-ca.rst \
393         doc/devnotes.rst \
394         doc/glossary.rst \
395         doc/hooks.rst \
396         doc/iallocator.rst \
397         doc/index.rst \
398         doc/install-quick.rst \
399         doc/install.rst \
400         doc/locking.rst \
401         doc/move-instance.rst \
402         doc/news.rst \
403         doc/ovfconverter.rst \
404         doc/rapi.rst \
405         doc/security.rst \
406         doc/upgrade.rst \
407         doc/virtual-cluster.rst \
408         doc/walkthrough.rst
409
410 HS_PROGS = htools/htools htools/mon-collector
411 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
412 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
413
414 HS_ALL_PROGS = \
415         $(HS_PROGS) \
416         htest/hpc-htools \
417         htest/hpc-mon-collector \
418         htest/test \
419         htools/hconfd \
420         htools/rpc-test
421
422 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
423 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
424
425 HFLAGS = \
426         -O -Wall -Werror -ihtools \
427         -fwarn-monomorphism-restriction \
428         -fwarn-tabs \
429         $(GHC_BYVERSION_FLAGS)
430
431 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
432 HEXTRA =
433 # internal extra flags (used for htest/test mainly)
434 HEXTRA_INT =
435 # exclude options for coverage reports
436 HPCEXCL = --exclude Main \
437         --exclude Ganeti.Constants \
438         --exclude Ganeti.HTools.QC \
439         --exclude Ganeti.THH \
440         --exclude Ganeti.Version \
441         --exclude Test.Ganeti.Attoparsec \
442         --exclude Test.Ganeti.TestCommon \
443         --exclude Test.Ganeti.TestHTools \
444         --exclude Test.Ganeti.TestHelper \
445         --exclude Test.Ganeti.TestImports \
446         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
447
448 HS_LIB_SRCS = \
449         htools/Ganeti/Block/Drbd/Types.hs \
450         htools/Ganeti/Block/Drbd/Parser.hs \
451         htools/Ganeti/BasicTypes.hs \
452         htools/Ganeti/Common.hs \
453         htools/Ganeti/Compat.hs \
454         htools/Ganeti/Confd/Client.hs \
455         htools/Ganeti/Confd/Server.hs \
456         htools/Ganeti/Confd/Types.hs \
457         htools/Ganeti/Confd/Utils.hs \
458         htools/Ganeti/Config.hs \
459         htools/Ganeti/Daemon.hs \
460         htools/Ganeti/DataCollectors/CLI.hs \
461         htools/Ganeti/DataCollectors/Drbd.hs \
462         htools/Ganeti/DataCollectors/Program.hs \
463         htools/Ganeti/Errors.hs \
464         htools/Ganeti/HTools/Backend/IAlloc.hs \
465         htools/Ganeti/HTools/Backend/Luxi.hs \
466         htools/Ganeti/HTools/Backend/Rapi.hs \
467         htools/Ganeti/HTools/Backend/Simu.hs \
468         htools/Ganeti/HTools/Backend/Text.hs \
469         htools/Ganeti/HTools/CLI.hs \
470         htools/Ganeti/HTools/Cluster.hs \
471         htools/Ganeti/HTools/Container.hs \
472         htools/Ganeti/HTools/ExtLoader.hs \
473         htools/Ganeti/HTools/Graph.hs \
474         htools/Ganeti/HTools/Group.hs \
475         htools/Ganeti/HTools/Instance.hs \
476         htools/Ganeti/HTools/Loader.hs \
477         htools/Ganeti/HTools/Node.hs \
478         htools/Ganeti/HTools/PeerMap.hs \
479         htools/Ganeti/HTools/Program.hs \
480         htools/Ganeti/HTools/Program/Hail.hs \
481         htools/Ganeti/HTools/Program/Hbal.hs \
482         htools/Ganeti/HTools/Program/Hcheck.hs \
483         htools/Ganeti/HTools/Program/Hinfo.hs \
484         htools/Ganeti/HTools/Program/Hscan.hs \
485         htools/Ganeti/HTools/Program/Hspace.hs \
486         htools/Ganeti/HTools/Program/Hroller.hs \
487         htools/Ganeti/HTools/Types.hs \
488         htools/Ganeti/Hash.hs \
489         htools/Ganeti/JQueue.hs \
490         htools/Ganeti/JSON.hs \
491         htools/Ganeti/Jobs.hs \
492         htools/Ganeti/Logging.hs \
493         htools/Ganeti/Luxi.hs \
494         htools/Ganeti/Network.hs \
495         htools/Ganeti/Objects.hs \
496         htools/Ganeti/OpCodes.hs \
497         htools/Ganeti/OpParams.hs \
498         htools/Ganeti/Path.hs \
499         htools/Ganeti/Query/Common.hs \
500         htools/Ganeti/Query/Filter.hs \
501         htools/Ganeti/Query/Group.hs \
502         htools/Ganeti/Query/Job.hs \
503         htools/Ganeti/Query/Language.hs \
504         htools/Ganeti/Query/Node.hs \
505         htools/Ganeti/Query/Query.hs \
506         htools/Ganeti/Query/Server.hs \
507         htools/Ganeti/Query/Types.hs \
508         htools/Ganeti/Rpc.hs \
509         htools/Ganeti/Runtime.hs \
510         htools/Ganeti/Ssconf.hs \
511         htools/Ganeti/THH.hs \
512         htools/Ganeti/Types.hs \
513         htools/Ganeti/Utils.hs
514
515 HS_TEST_SRCS = \
516         htest/Test/Ganeti/Attoparsec.hs \
517         htest/Test/Ganeti/BasicTypes.hs \
518         htest/Test/Ganeti/Block/Drbd/Parser.hs \
519         htest/Test/Ganeti/Block/Drbd/Types.hs \
520         htest/Test/Ganeti/Common.hs \
521         htest/Test/Ganeti/Confd/Types.hs \
522         htest/Test/Ganeti/Confd/Utils.hs \
523         htest/Test/Ganeti/Daemon.hs \
524         htest/Test/Ganeti/Errors.hs \
525         htest/Test/Ganeti/HTools/Backend/Simu.hs \
526         htest/Test/Ganeti/HTools/Backend/Text.hs \
527         htest/Test/Ganeti/HTools/CLI.hs \
528         htest/Test/Ganeti/HTools/Cluster.hs \
529         htest/Test/Ganeti/HTools/Container.hs \
530         htest/Test/Ganeti/HTools/Graph.hs \
531         htest/Test/Ganeti/HTools/Instance.hs \
532         htest/Test/Ganeti/HTools/Loader.hs \
533         htest/Test/Ganeti/HTools/Node.hs \
534         htest/Test/Ganeti/HTools/PeerMap.hs \
535         htest/Test/Ganeti/HTools/Types.hs \
536         htest/Test/Ganeti/JSON.hs \
537         htest/Test/Ganeti/Jobs.hs \
538         htest/Test/Ganeti/JQueue.hs \
539         htest/Test/Ganeti/Luxi.hs \
540         htest/Test/Ganeti/Network.hs \
541         htest/Test/Ganeti/Objects.hs \
542         htest/Test/Ganeti/OpCodes.hs \
543         htest/Test/Ganeti/Query/Filter.hs \
544         htest/Test/Ganeti/Query/Language.hs \
545         htest/Test/Ganeti/Query/Query.hs \
546         htest/Test/Ganeti/Rpc.hs \
547         htest/Test/Ganeti/Ssconf.hs \
548         htest/Test/Ganeti/THH.hs \
549         htest/Test/Ganeti/TestCommon.hs \
550         htest/Test/Ganeti/TestHTools.hs \
551         htest/Test/Ganeti/TestHelper.hs \
552         htest/Test/Ganeti/Types.hs \
553         htest/Test/Ganeti/Utils.hs
554
555 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
556
557 HS_BUILT_SRCS = \
558         htest/Test/Ganeti/TestImports.hs \
559         htools/Ganeti/Constants.hs \
560         htools/Ganeti/Version.hs
561 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
562
563 $(RUN_IN_TEMPDIR): | stamp-directories
564
565 # Note: we use here an order-only prerequisite, as the contents of
566 # _autoconf.py are not actually influencing the html build output: it
567 # has to exist in order for the sphinx module to be loaded
568 # successfully, but we certainly don't want the docs to be rebuilt if
569 # it changes
570 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
571         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
572         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
573         | $(BUILT_PYTHON_SOURCES)
574         @test -n "$(SPHINX)" || \
575             { echo 'sphinx-build' not found during configure; exit 1; }
576         @mkdir_p@ $(dir $@)
577         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
578             -d . \
579             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
580             -D release="$(PACKAGE_VERSION)" \
581             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
582         rm -f doc/html/.buildinfo doc/html/objects.inv
583         touch $@
584
585 doc/html: doc/html/index.html
586
587 doc/install-quick.rst: INSTALL
588 doc/news.rst: NEWS
589 doc/upgrade.rst: UPGRADE
590
591 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
592         set -e; \
593         { echo '.. This file is automatically updated at build time from $<.'; \
594           echo '.. Do not edit.'; \
595           echo; \
596           cat $<; \
597         } > $@
598
599 docdot = \
600         doc/arch-2.0.dot \
601         doc/design-2.1-lock-acquire.dot \
602         doc/design-2.1-lock-release.dot
603
604 docpng = $(patsubst %.dot,%.png,$(docdot))
605
606 # Things to build but not to install (add it to EXTRA_DIST if it should be
607 # distributed)
608 noinst_DATA = \
609         doc/html \
610         $(BUILT_EXAMPLES) \
611         doc/examples/bash_completion \
612         doc/examples/bash_completion-debug \
613         $(manhtml)
614
615 gnt_scripts = \
616         scripts/gnt-backup \
617         scripts/gnt-cluster \
618         scripts/gnt-debug \
619         scripts/gnt-group \
620         scripts/gnt-instance \
621         scripts/gnt-job \
622         scripts/gnt-network \
623         scripts/gnt-node \
624         scripts/gnt-os
625
626 PYTHON_BOOTSTRAP_SBIN = \
627         daemons/ganeti-masterd \
628         daemons/ganeti-noded \
629         daemons/ganeti-rapi \
630         daemons/ganeti-watcher \
631         $(gnt_scripts)
632
633 PYTHON_BOOTSTRAP = \
634         $(PYTHON_BOOTSTRAP_SBIN) \
635         tools/ensure-dirs \
636         tools/node-cleanup \
637         tools/node-daemon-setup \
638         tools/prepare-node-join
639
640 qa_scripts = \
641         qa/__init__.py \
642         qa/ganeti-qa.py \
643         qa/qa_cluster.py \
644         qa/qa_config.py \
645         qa/qa_daemon.py \
646         qa/qa_env.py \
647         qa/qa_error.py \
648         qa/qa_group.py \
649         qa/qa_instance.py \
650         qa/qa_job.py \
651         qa/qa_node.py \
652         qa/qa_os.py \
653         qa/qa_rapi.py \
654         qa/qa_tags.py \
655         qa/qa_utils.py
656
657 bin_SCRIPTS =
658 if WANT_HTOOLS
659 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
660 install-exec-hook:
661         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
662 # FIXME: this is a hardcoded logic, instead of auto-resolving
663         $(LN_S) -f ../../../bin/htools \
664           $(DESTDIR)$(iallocatorsdir)/hail
665         for role in $(HS_BIN_ROLES); do \
666           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
667         done
668 endif
669
670 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
671         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
672           echo "Error: cannot run unittests without the development" \
673                " libraries (see devnotes.rst)" 1>&2; \
674           exit 1; \
675         fi
676         @rm -f $(notdir $@).tix
677         $(GHC) --make \
678           $(HFLAGS) \
679           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
680           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
681           $(HEXTRA) $(HEXTRA_INT) $@
682         @touch "$@"
683
684 # for the htest/test binary, we need to enable profiling/coverage
685 htest/test: HEXTRA_INT=-fhpc -ihtest
686
687 # we compile the hpc-htools binary with the program coverage
688 htest/hpc-htools: HEXTRA_INT=-fhpc
689
690 # we compile the hpc-mon-collector binary with the program coverage
691 htest/hpc-mon-collector: HEXTRA_INT=-fhpc
692
693 # test dependency
694 htest/offline-tests.sh: htest/hpc-htools htest/hpc-mon-collector
695
696 # rules for building profiling-enabled versions of the haskell
697 # programs: hs-prof does the full two-step build, whereas
698 # hs-prof-quick does only the final rebuild (hs-prof must have been
699 # run before)
700 .PHONY: hs-prof hs-prof-quick
701 hs-prof:
702         @if [ -z "$(TARGET)" ]; then \
703           echo "You need to define TARGET when running this rule" 1>&2; \
704           exit 1; \
705         fi
706         $(MAKE) $(AM_MAKEFLAGS) clean
707         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
708         rm -f $(HS_ALL_PROGS)
709         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
710
711 hs-prof-quick:
712         @if [ -z "$(TARGET)" ]; then \
713           echo "You need to define TARGET when running this rule" 1>&2; \
714           exit 1; \
715         fi
716         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
717
718 dist_sbin_SCRIPTS = \
719         tools/ganeti-listrunner
720
721 nodist_sbin_SCRIPTS = \
722         $(PYTHON_BOOTSTRAP_SBIN) \
723         daemons/ganeti-cleaner
724
725 if ENABLE_CONFD
726 htools/ganeti-confd: htools/hconfd
727         cp -f $< $@
728
729 nodist_sbin_SCRIPTS += htools/ganeti-confd
730 endif
731
732 python_scripts = \
733         tools/burnin \
734         tools/cfgshell \
735         tools/cfgupgrade \
736         tools/cfgupgrade12 \
737         tools/cluster-merge \
738         tools/confd-client \
739         tools/fmtjson \
740         tools/lvmstrap \
741         tools/move-instance \
742         tools/ovfconverter \
743         tools/sanitize-config
744
745 dist_tools_SCRIPTS = \
746         $(python_scripts) \
747         tools/kvm-console-wrapper \
748         tools/master-ip-setup \
749         tools/xen-console-wrapper
750
751 nodist_tools_python_scripts = \
752         tools/node-cleanup
753
754 nodist_tools_SCRIPTS = \
755         $(nodist_tools_python_scripts) \
756         tools/vcluster-setup
757
758 pkglib_python_scripts = \
759         daemons/import-export \
760         tools/check-cert-expired
761
762 nodist_pkglib_python_scripts = \
763         tools/ensure-dirs \
764         tools/node-daemon-setup \
765         tools/prepare-node-join
766
767 myexeclib_SCRIPTS = \
768         daemons/daemon-util \
769         tools/kvm-ifup \
770         $(pkglib_python_scripts) \
771         htools/mon-collector
772
773 nodist_myexeclib_SCRIPTS = \
774         $(nodist_pkglib_python_scripts)
775
776 EXTRA_DIST = \
777         NEWS \
778         UPGRADE \
779         epydoc.conf.in \
780         pylintrc \
781         autotools/build-bash-completion \
782         autotools/build-rpc \
783         autotools/check-header \
784         autotools/check-imports \
785         autotools/check-man-dashes \
786         autotools/check-man-warnings \
787         autotools/check-news \
788         autotools/check-python-code \
789         autotools/check-tar \
790         autotools/check-version \
791         autotools/convert-constants \
792         autotools/docpp \
793         autotools/gen-coverage \
794         autotools/testrunner \
795         autotools/wrong-hardcoded-paths \
796         $(RUN_IN_TEMPDIR) \
797         daemons/daemon-util.in \
798         daemons/ganeti-cleaner.in \
799         $(pkglib_python_scripts) \
800         devel/upload \
801         tools/kvm-ifup.in \
802         tools/vcluster-setup.in \
803         $(docdot) \
804         $(docpng) \
805         $(docrst) \
806         doc/conf.py \
807         doc/html \
808         $(BUILT_EXAMPLES:%=%.in) \
809         doc/examples/ganeti.default \
810         doc/examples/ganeti.default-debug \
811         doc/examples/hooks/ethers \
812         doc/examples/gnt-debug/README \
813         doc/examples/gnt-debug/delay0.json \
814         doc/examples/gnt-debug/delay50.json \
815         test/lockperf.py \
816         test/testutils.py \
817         test/mocks.py \
818         $(dist_TESTS) \
819         $(TEST_FILES) \
820         man/footer.rst \
821         $(manrst) \
822         $(maninput) \
823         qa/qa-sample.json \
824         $(qa_scripts) \
825         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
826         $(HS_PROG_SRCS) \
827         htools/lint-hints.hs \
828         htest/cli-tests-defs.sh \
829         htest/offline-test.sh \
830         .ghci
831
832 man_MANS = \
833         man/ganeti-cleaner.8 \
834         man/ganeti-confd.8 \
835         man/ganeti-listrunner.8 \
836         man/ganeti-masterd.8 \
837         man/ganeti-noded.8 \
838         man/ganeti-os-interface.7 \
839         man/ganeti-rapi.8 \
840         man/ganeti-watcher.8 \
841         man/ganeti.7 \
842         man/gnt-backup.8 \
843         man/gnt-cluster.8 \
844         man/gnt-debug.8 \
845         man/gnt-group.8 \
846         man/gnt-network.8 \
847         man/gnt-instance.8 \
848         man/gnt-job.8 \
849         man/gnt-node.8 \
850         man/gnt-os.8 \
851         man/hail.1 \
852         man/hbal.1 \
853         man/hcheck.1 \
854         man/hinfo.1 \
855         man/hscan.1 \
856         man/hspace.1 \
857         man/hroller.1 \
858         man/htools.1 \
859         man/mon-collector.7
860
861 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
862 manhtml = $(patsubst %.rst,%.html,$(manrst))
863 mangen = $(patsubst %.rst,%.gen,$(manrst))
864 maninput = \
865         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
866         $(patsubst %.html,%.html.in,$(manhtml)) \
867         man/footer.man man/footer.html $(mangen)
868
869 TEST_FILES = \
870         htest/data/common-suffix.data \
871         htest/data/empty-cluster.data \
872         htest/data/hail-alloc-drbd.json \
873         htest/data/hail-change-group.json \
874         htest/data/hail-invalid-reloc.json \
875         htest/data/hail-node-evac.json \
876         htest/data/hail-reloc-drbd.json \
877         htest/data/hbal-excl-tags.data \
878         htest/data/hbal-split-insts.data \
879         htest/data/invalid-node.data \
880         htest/data/missing-resources.data \
881         htest/data/rapi/groups.json \
882         htest/data/rapi/info.json \
883         htest/data/rapi/instances.json \
884         htest/data/rapi/nodes.json \
885         htest/shelltests/htools-balancing.test \
886         htest/shelltests/htools-basic.test \
887         htest/shelltests/htools-dynutil.test \
888         htest/shelltests/htools-excl.test \
889         htest/shelltests/htools-hail.test \
890         htest/shelltests/htools-hspace.test \
891         htest/shelltests/htools-invalid.test \
892         htest/shelltests/htools-multi-group.test \
893         htest/shelltests/htools-no-backend.test \
894         htest/shelltests/htools-rapi.test \
895         htest/shelltests/htools-single-group.test \
896         htest/shelltests/htools-text-backend.test \
897         htest/shelltests/htools-mon-collector.test \
898         test/data/bdev-drbd-8.0.txt \
899         test/data/bdev-drbd-8.3.txt \
900         test/data/bdev-drbd-disk.txt \
901         test/data/bdev-drbd-net-ip4.txt \
902         test/data/bdev-drbd-net-ip6.txt \
903         test/data/cert1.pem \
904         test/data/cert2.pem \
905         test/data/ip-addr-show-dummy0.txt \
906         test/data/ip-addr-show-lo-ipv4.txt \
907         test/data/ip-addr-show-lo-ipv6.txt \
908         test/data/ip-addr-show-lo-oneline-ipv4.txt \
909         test/data/ip-addr-show-lo-oneline-ipv6.txt \
910         test/data/ip-addr-show-lo-oneline.txt \
911         test/data/ip-addr-show-lo.txt \
912         test/data/kvm_0.12.5_help.txt \
913         test/data/kvm_0.15.90_help.txt \
914         test/data/kvm_0.9.1_help.txt \
915         test/data/kvm_1.0_help.txt \
916         test/data/ovfdata/compr_disk.vmdk.gz \
917         test/data/ovfdata/config.ini \
918         test/data/ovfdata/corrupted_resources.ovf \
919         test/data/ovfdata/empty.ini \
920         test/data/ovfdata/empty.ovf \
921         test/data/ovfdata/ganeti.mf \
922         test/data/ovfdata/ganeti.ovf \
923         test/data/ovfdata/gzip_disk.ovf \
924         test/data/ovfdata/new_disk.vmdk \
925         test/data/ovfdata/no_disk.ini \
926         test/data/ovfdata/no_disk_in_ref.ovf \
927         test/data/ovfdata/no_os.ini \
928         test/data/ovfdata/no_ovf.ova \
929         test/data/ovfdata/other/rawdisk.raw \
930         test/data/ovfdata/ova.ova \
931         test/data/ovfdata/rawdisk.raw \
932         test/data/ovfdata/second_disk.vmdk \
933         test/data/ovfdata/unsafe_path.ini \
934         test/data/ovfdata/virtualbox.ovf \
935         test/data/ovfdata/wrong_config.ini \
936         test/data/ovfdata/wrong_extension.ovd \
937         test/data/ovfdata/wrong_manifest.mf \
938         test/data/ovfdata/wrong_manifest.ovf \
939         test/data/ovfdata/wrong_ova.ova \
940         test/data/ovfdata/wrong_xml.ovf \
941         test/data/proc_drbd8.txt \
942         test/data/proc_drbd80-emptyline.txt \
943         test/data/proc_drbd83.txt \
944         test/data/proc_drbd83_sync.txt \
945         test/data/proc_drbd83_sync_want.txt \
946         test/data/proc_drbd83_sync_krnl2.6.39.txt \
947         test/data/sys_drbd_usermode_helper.txt \
948         test/data/vgreduce-removemissing-2.02.02.txt \
949         test/data/vgreduce-removemissing-2.02.66-fail.txt \
950         test/data/vgreduce-removemissing-2.02.66-ok.txt \
951         test/data/vgs-missing-pvs-2.02.02.txt \
952         test/data/vgs-missing-pvs-2.02.66.txt \
953         test/ganeti-cli.test \
954         test/gnt-cli.test \
955         test/import-export_unittest-helper
956
957 python_tests = \
958         doc/examples/rapi_testutils.py \
959         test/cfgupgrade_unittest.py \
960         test/docs_unittest.py \
961         test/ganeti.asyncnotifier_unittest.py \
962         test/ganeti.backend_unittest-runasroot.py \
963         test/ganeti.backend_unittest.py \
964         test/ganeti.bdev_unittest.py \
965         test/ganeti.cli_unittest.py \
966         test/ganeti.client.gnt_cluster_unittest.py \
967         test/ganeti.client.gnt_instance_unittest.py \
968         test/ganeti.client.gnt_job_unittest.py \
969         test/ganeti.cmdlib_unittest.py \
970         test/ganeti.compat_unittest.py \
971         test/ganeti.confd.client_unittest.py \
972         test/ganeti.config_unittest.py \
973         test/ganeti.constants_unittest.py \
974         test/ganeti.daemon_unittest.py \
975         test/ganeti.errors_unittest.py \
976         test/ganeti.hooks_unittest.py \
977         test/ganeti.ht_unittest.py \
978         test/ganeti.http_unittest.py \
979         test/ganeti.hypervisor.hv_chroot_unittest.py \
980         test/ganeti.hypervisor.hv_fake_unittest.py \
981         test/ganeti.hypervisor.hv_kvm_unittest.py \
982         test/ganeti.hypervisor.hv_lxc_unittest.py \
983         test/ganeti.hypervisor.hv_xen_unittest.py \
984         test/ganeti.hypervisor_unittest.py \
985         test/ganeti.impexpd_unittest.py \
986         test/ganeti.jqueue_unittest.py \
987         test/ganeti.jstore_unittest.py \
988         test/ganeti.locking_unittest.py \
989         test/ganeti.luxi_unittest.py \
990         test/ganeti.masterd.iallocator_unittest.py \
991         test/ganeti.masterd.instance_unittest.py \
992         test/ganeti.mcpu_unittest.py \
993         test/ganeti.netutils_unittest.py \
994         test/ganeti.objects_unittest.py \
995         test/ganeti.objectutils_unittest.py \
996         test/ganeti.opcodes_unittest.py \
997         test/ganeti.ovf_unittest.py \
998         test/ganeti.qlang_unittest.py \
999         test/ganeti.query_unittest.py \
1000         test/ganeti.rapi.baserlib_unittest.py \
1001         test/ganeti.rapi.client_unittest.py \
1002         test/ganeti.rapi.resources_unittest.py \
1003         test/ganeti.rapi.rlib2_unittest.py \
1004         test/ganeti.rapi.testutils_unittest.py \
1005         test/ganeti.rpc_unittest.py \
1006         test/ganeti.runtime_unittest.py \
1007         test/ganeti.serializer_unittest.py \
1008         test/ganeti.server.rapi_unittest.py \
1009         test/ganeti.ssconf_unittest.py \
1010         test/ganeti.ssh_unittest.py \
1011         test/ganeti.storage_unittest.py \
1012         test/ganeti.tools.ensure_dirs_unittest.py \
1013         test/ganeti.tools.node_daemon_setup_unittest.py \
1014         test/ganeti.tools.prepare_node_join_unittest.py \
1015         test/ganeti.uidpool_unittest.py \
1016         test/ganeti.utils.algo_unittest.py \
1017         test/ganeti.utils.filelock_unittest.py \
1018         test/ganeti.utils.hash_unittest.py \
1019         test/ganeti.utils.io_unittest-runasroot.py \
1020         test/ganeti.utils.io_unittest.py \
1021         test/ganeti.utils.log_unittest.py \
1022         test/ganeti.utils.mlock_unittest.py \
1023         test/ganeti.utils.nodesetup_unittest.py \
1024         test/ganeti.utils.process_unittest.py \
1025         test/ganeti.utils.retry_unittest.py \
1026         test/ganeti.utils.text_unittest.py \
1027         test/ganeti.utils.wrapper_unittest.py \
1028         test/ganeti.utils.x509_unittest.py \
1029         test/ganeti.utils_unittest.py \
1030         test/ganeti.vcluster_unittest.py \
1031         test/ganeti.workerpool_unittest.py \
1032         test/pycurl_reset_unittest.py \
1033         test/qa.qa_config_unittest.py \
1034         test/tempfile_fork_unittest.py
1035
1036 haskell_tests = htest/test
1037
1038 dist_TESTS = \
1039         test/check-cert-expired_unittest.bash \
1040         test/daemon-util_unittest.bash \
1041         test/ganeti-cleaner_unittest.bash \
1042         test/import-export_unittest.bash \
1043         test/cli-test.bash \
1044         test/bash_completion.bash \
1045         $(python_tests)
1046
1047 nodist_TESTS =
1048 check_SCRIPTS =
1049
1050 if WANT_HTOOLSTESTS
1051 nodist_TESTS += $(haskell_tests)
1052 dist_TESTS += htest/offline-test.sh
1053 check_SCRIPTS += \
1054         htest/hpc-htools \
1055         htest/hpc-mon-collector \
1056         $(HS_BUILT_TEST_HELPERS)
1057 endif
1058
1059 TESTS = $(dist_TESTS) $(nodist_TESTS)
1060
1061 # Environment for all tests
1062 PLAIN_TESTS_ENVIRONMENT = \
1063         PYTHONPATH=. \
1064         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1065         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1066         $(RUN_IN_TEMPDIR)
1067
1068 # Environment for tests run by automake
1069 TESTS_ENVIRONMENT = \
1070         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1071
1072 all_python_code = \
1073         $(dist_sbin_SCRIPTS) \
1074         $(python_scripts) \
1075         $(pkglib_python_scripts) \
1076         $(nodist_pkglib_python_scripts) \
1077         $(nodist_tools_python_scripts) \
1078         $(python_tests) \
1079         $(pkgpython_PYTHON) \
1080         $(client_PYTHON) \
1081         $(hypervisor_PYTHON) \
1082         $(rapi_PYTHON) \
1083         $(server_PYTHON) \
1084         $(pytools_PYTHON) \
1085         $(http_PYTHON) \
1086         $(confd_PYTHON) \
1087         $(masterd_PYTHON) \
1088         $(impexpd_PYTHON) \
1089         $(utils_PYTHON) \
1090         $(watcher_PYTHON) \
1091         $(noinst_PYTHON) \
1092         $(qa_scripts)
1093
1094 srclink_files = \
1095         man/footer.rst \
1096         test/check-cert-expired_unittest.bash \
1097         test/daemon-util_unittest.bash \
1098         test/ganeti-cleaner_unittest.bash \
1099         test/import-export_unittest.bash \
1100         test/cli-test.bash \
1101         test/bash_completion.bash \
1102         htest/offline-test.sh \
1103         htest/cli-tests-defs.sh \
1104         $(all_python_code) \
1105         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1106
1107 check_python_code = \
1108         $(BUILD_BASH_COMPLETION) \
1109         $(CHECK_IMPORTS) \
1110         $(CHECK_HEADER) \
1111         $(DOCPP) \
1112         $(all_python_code)
1113
1114 lint_python_code = \
1115         ganeti \
1116         ganeti/http/server.py \
1117         $(dist_sbin_SCRIPTS) \
1118         $(python_scripts) \
1119         $(pkglib_python_scripts) \
1120         $(BUILD_BASH_COMPLETION) \
1121         $(CHECK_IMPORTS) \
1122         $(CHECK_HEADER) \
1123         $(DOCPP) \
1124         $(PYTHON_BOOTSTRAP)
1125
1126 standalone_python_modules = \
1127         lib/rapi/client.py \
1128         tools/ganeti-listrunner
1129
1130 pep8_python_code = \
1131         ganeti \
1132         ganeti/http/server.py \
1133         $(dist_sbin_SCRIPTS) \
1134         $(python_scripts) \
1135         $(pkglib_python_scripts) \
1136         $(BUILD_BASH_COMPLETION) \
1137         $(CHECK_HEADER) \
1138         $(DOCPP) \
1139         $(PYTHON_BOOTSTRAP) \
1140         qa
1141
1142 test/daemon-util_unittest.bash: daemons/daemon-util
1143
1144 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1145
1146 test/bash_completion.bash: doc/examples/bash_completion-debug
1147
1148 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1149         sed -f $(REPLACE_VARS_SED) < $< > $@
1150         chmod +x $@
1151
1152 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1153         sed -f $(REPLACE_VARS_SED) < $< > $@
1154         chmod +x $@
1155
1156 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1157         sed -f $(REPLACE_VARS_SED) < $< > $@
1158         chmod +x $@
1159
1160 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1161         sed -f $(REPLACE_VARS_SED) < $< > $@
1162
1163 doc/examples/bash_completion: BC_ARGS = --compact
1164 doc/examples/bash_completion-debug: BC_ARGS =
1165
1166 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1167         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1168         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1169         daemons/ganeti-cleaner \
1170         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1171         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1172           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1173
1174 doc/%.png: doc/%.dot
1175         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1176         $(DOT) -Tpng -o $@ $<
1177
1178 man/footer.man: man/footer.rst
1179         @test -n "$(PANDOC)" || \
1180           { echo 'pandoc' not found during configure; exit 1; }
1181         $(PANDOC) -f rst -t man -o $@ $<
1182
1183 man/footer.html: man/footer.rst
1184         @test -n "$(PANDOC)" || \
1185           { echo 'pandoc' not found during configure; exit 1; }
1186         $(PANDOC) -f rst -t html -o $@ $<
1187
1188 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1189         lib/build/shell_example_lexer.py \
1190         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1191         @echo "Checking $< for hardcoded paths..."
1192         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1193           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1194           exit 1; \
1195         fi
1196         set -e ; \
1197         trap 'echo auto-removing $@; rm $@' EXIT; \
1198         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1199         trap - EXIT
1200
1201 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1202         @test -n "$(PANDOC)" || \
1203           { echo 'pandoc' not found during configure; exit 1; }
1204         set -o pipefail ; \
1205         trap 'echo auto-removing $@; rm $@' EXIT; \
1206         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1207           sed -e 's/\\@/@/g' > $@; \
1208         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1209         $(CHECK_MAN_DASHES) $@; \
1210         trap - EXIT
1211
1212
1213 man/%.html.in: man/%.gen man/footer.html
1214         @test -n "$(PANDOC)" || \
1215           { echo 'pandoc' not found during configure; exit 1; }
1216         set -o pipefail ; \
1217         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1218           sed -e 's/\\@/@/g' > $@
1219
1220 man/%: man/%.in  $(REPLACE_VARS_SED)
1221         sed -f $(REPLACE_VARS_SED) < $< > $@
1222
1223 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1224         sed -f $(REPLACE_VARS_SED) < $< > $@
1225
1226 vcs-version:
1227         if test -d .git; then \
1228           git describe > $@; \
1229         elif test ! -f $@ ; then \
1230           echo "Cannot auto-generate $@ file"; exit 1; \
1231         fi
1232
1233 .PHONY: clean-vcs-version
1234 clean-vcs-version:
1235         rm -f vcs-version
1236
1237 .PHONY: regen-vcs-version
1238 regen-vcs-version:
1239         @set -e; \
1240         cd $(srcdir); \
1241         if test -d .git; then \
1242           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1243           git describe > $$T; \
1244           if ! cmp --quiet $$T vcs-version; then \
1245             mv $$T vcs-version; \
1246           fi; \
1247         fi
1248
1249 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1250         vcs-version $(built_base_sources)
1251         set -e; \
1252         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1253         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1254
1255 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1256         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1257         lib/jstore.py \
1258         $(CONVERT_CONSTANTS) $(built_base_sources) \
1259         | lib/_vcsversion.py
1260         set -e; \
1261         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1262
1263 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1264         $(built_base_sources)
1265         set -e; \
1266         { cat $< ; \
1267           echo ; \
1268           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1269             echo "import $$name ()" ; \
1270           done ; \
1271         } > $@
1272
1273 lib/_autoconf.py: Makefile | stamp-directories
1274         set -e; \
1275         { echo '# This file is automatically generated, do not edit!'; \
1276           echo '#'; \
1277           echo ''; \
1278           echo '"""Build-time configuration for Ganeti.'; \
1279           echo '';\
1280           echo 'This file is autogenerated by the build process.'; \
1281           echo 'For any changes you need to re-run ./configure (and'; \
1282           echo 'not edit by hand).'; \
1283           echo ''; \
1284           echo '"""'; \
1285           echo ''; \
1286           echo '# pylint: disable=C0301,C0324'; \
1287           echo '# because this is autogenerated, we do not want'; \
1288           echo '# style warnings' ; \
1289           echo ''; \
1290           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1291           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1292           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1293           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1294           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1295           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1296           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1297           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1298           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1299           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1300           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1301           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1302           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1303           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1304           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1305           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1306           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1307           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1308           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1309           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1310           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1311           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1312           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1313           echo "KVM_PATH = '$(KVM_PATH)'"; \
1314           echo "IP_PATH = '$(IP_PATH)'"; \
1315           echo "SOCAT_PATH = '$(SOCAT)'"; \
1316           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1317           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1318           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1319           echo "TOOLSDIR = '$(toolsdir)'"; \
1320           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1321           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1322           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1323           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1324           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1325           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1326           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1327           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1328           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1329           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1330           echo "RAPI_USER = '$(RAPI_USER)'"; \
1331           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1332           echo "CONFD_USER = '$(CONFD_USER)'"; \
1333           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1334           echo "NODED_USER = '$(NODED_USER)'"; \
1335           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1336           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1337           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1338           echo "HTOOLS = True"; \
1339           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1340           echo "XEN_CMD = '$(XEN_CMD)'"; \
1341           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1342           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1343           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1344         } > $@
1345
1346 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1347         set -e; \
1348         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1349         { echo '# This file is automatically generated, do not edit!'; \
1350           echo '#'; \
1351           echo ''; \
1352           echo '"""Build-time VCS version number for Ganeti.'; \
1353           echo '';\
1354           echo 'This file is autogenerated by the build process.'; \
1355           echo 'For any changes you need to re-run ./configure (and'; \
1356           echo 'not edit by hand).'; \
1357           echo ''; \
1358           echo '"""'; \
1359           echo ''; \
1360           echo '# pylint: disable=C0301,C0324'; \
1361           echo '# because this is autogenerated, we do not want'; \
1362           echo '# style warnings' ; \
1363           echo ''; \
1364           echo "VCS_VERSION = '$$VCSVER'"; \
1365         } > $@
1366
1367 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1368         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1369
1370 $(SHELL_ENV_INIT): Makefile stamp-directories
1371         set -e; \
1372         { echo '# Allow overriding for tests'; \
1373           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1374           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1375           echo; \
1376           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1377           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1378           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1379           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1380           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1381         } > $@
1382
1383 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1384         set -e; \
1385         { echo 's#@PREFIX@#$(prefix)#g'; \
1386           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1387           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1388           echo 's#@BINDIR@#$(bindir)#g'; \
1389           echo 's#@SBINDIR@#$(sbindir)#g'; \
1390           echo 's#@LIBDIR@#$(libdir)#g'; \
1391           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1392           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1393           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1394           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1395           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1396           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1397           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1398           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1399           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1400           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1401           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1402           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1403           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1404           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1405           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1406           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1407           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1408           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1409           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1410           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1411           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1412           echo; \
1413           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1414           echo '  r $(SHELL_ENV_INIT)'; \
1415           echo '  d'; \
1416           echo '}'; \
1417         } > $@
1418
1419 # Using deferred evaluation
1420 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1421 daemons/ganeti-watcher: MODULE = ganeti.watcher
1422 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1423 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1424 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1425 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1426 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1427 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1428
1429 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1430         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1431         set -e; \
1432         { echo '#!/usr/bin/python'; \
1433           echo '# This file is automatically generated, do not edit!'; \
1434           echo "# Edit $(MODULE) instead."; \
1435           echo; \
1436           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1437           echo; \
1438           echo '# pylint: disable=C0103'; \
1439           echo '# C0103: Invalid name'; \
1440           echo; \
1441           echo 'import sys'; \
1442           echo 'import $(MODULE) as main'; \
1443           echo; \
1444           echo '# Temporarily alias commands until bash completion'; \
1445           echo '# generator is changed'; \
1446           echo 'if hasattr(main, "commands"):'; \
1447           echo '  commands = main.commands # pylint: disable=E1101'; \
1448           echo 'if hasattr(main, "aliases"):'; \
1449           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1450           echo; \
1451           echo 'if __name__ == "__main__":'; \
1452           echo '  sys.exit(main.Main())'; \
1453         } > $@
1454         chmod u+x $@
1455
1456 $(HS_BUILT_TEST_HELPERS): Makefile
1457         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1458         set -e; \
1459         { echo '#!/bin/sh'; \
1460           echo '# This file is automatically generated, do not edit!'; \
1461           echo "# Edit Makefile.am instead."; \
1462           echo; \
1463           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1464         } > $@
1465         chmod u+x $@
1466
1467 stamp-directories: Makefile
1468         $(MAKE) $(AM_MAKEFLAGS) ganeti
1469         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1470         touch $@
1471
1472 # We need to create symlinks because "make distcheck" will not install Python
1473 # files when building.
1474 stamp-srclinks: Makefile | stamp-directories
1475         set -e; \
1476         for i in $(srclink_files); do \
1477           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1478             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1479           fi; \
1480         done
1481         touch $@
1482
1483 .PHONY: ganeti
1484 ganeti:
1485         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1486
1487 .PHONY: check-dirs
1488 check-dirs: $(GENERATED_FILES)
1489         @set -e; \
1490         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1491           error=; \
1492           while read dir; do \
1493             case "$$dir" in \
1494               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1495               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1496             esac; \
1497           done; \
1498           for dir in $(DIRS); do \
1499             if ! test -d "$$dir"; then \
1500               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1501               error=1; \
1502             fi \
1503           done; \
1504           test -z "$$error"; \
1505         }
1506
1507 .PHONY: check-local
1508 check-local: check-dirs $(GENERATED_FILES)
1509         $(CHECK_PYTHON_CODE) $(check_python_code)
1510         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1511         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1512         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1513         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1514         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1515         error= ; \
1516         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1517           echo "Incorrect version in README, expected $$expver" >&2; \
1518           error=1; \
1519         fi; \
1520         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1521             doc/security.rst; do \
1522           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1523             "Documents Ganeti version $$expver"; then \
1524             echo "Incorrect version in $$file, expected $$expver" >&2; \
1525             error=1; \
1526           fi; \
1527         done; \
1528         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1529           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1530           error=1; \
1531         fi; \
1532         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1533           ".. Last updated for Ganeti $$expver"; then \
1534           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1535           error=1; \
1536         fi; \
1537         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1538           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1539             echo "Longest line in $$file is longer than 80 characters" >&2; \
1540             error=1; \
1541           fi; \
1542         done; \
1543         test -z "$$error"
1544
1545 .PHONY: hs-check
1546 hs-check: htest/test htest/hpc-htools htest/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1547         @rm -f *.tix
1548         ./htest/test
1549         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1550
1551 # E111: indentation is not a multiple of four
1552 # E121: continuation line indentation is not a multiple of four
1553 #       (since our indent level is not 4)
1554 # E125: continuation line does not distinguish itself from next logical line
1555 #       (since our indent level is not 4)
1556 # E127: continuation line over-indented for visual indent
1557 #       (since our indent level is not 4)
1558 # note: do NOT add E128 here; it's a valid style error in most cases!
1559 # I've seen real errors, but also some cases were we indent wrongly
1560 # due to line length; try to rework the cases where it is triggered,
1561 # instead of silencing it
1562 # E261: at least two spaces before inline comment
1563 # E501: line too long (80 characters)
1564 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1565
1566 # For excluding pep8 expects filenames only, not whole paths
1567 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1568
1569 LINT_TARGETS = pylint pylint-qa
1570 if HAS_PEP8
1571 LINT_TARGETS += pep8
1572 endif
1573 if HAS_HLINT
1574 LINT_TARGETS += hlint
1575 endif
1576
1577 .PHONY: lint
1578 lint: $(LINT_TARGETS)
1579
1580 .PHONY: pylint
1581 pylint: $(GENERATED_FILES)
1582         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1583         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1584
1585 .PHONY: pylint-qa
1586 pylint-qa: $(GENERATED_FILES)
1587         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1588         cd $(top_srcdir)/qa && \
1589           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1590           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1591
1592 .PHONY: pep8
1593 pep8: $(GENERATED_FILES)
1594         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1595         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1596           --repeat $(pep8_python_code)
1597
1598 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1599 HLINT_EXCLUDES = htools/Ganeti/THH.hs htest/hpc-htools.hs
1600 .PHONY: hlint
1601 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1602         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1603         if tty -s; then C="-c"; else C=""; fi; \
1604         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1605           --ignore "Use first" \
1606           --ignore "Use &&&" \
1607           --ignore "Use void" \
1608           --ignore "Reduce duplication" \
1609           --hint htools/lint-hints \
1610           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1611
1612 # a dist hook rule for updating the vcs-version file; this is
1613 # hardcoded due to where it needs to build the file...
1614 dist-hook:
1615         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1616         rm -f $(top_distdir)/vcs-version
1617         cp -p $(srcdir)/vcs-version $(top_distdir)
1618
1619 # a distcheck hook rule for catching revision control directories
1620 distcheck-hook:
1621         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1622           echo "Found revision control files in final archive." 1>&2; \
1623           exit 1; \
1624         fi
1625         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1626           echo "Found Python byte code in final archive." 1>&2; \
1627           exit 1; \
1628         fi
1629         if find $(top_distdir) -name '*~' | grep .; then \
1630           echo "Found backup files in final archive." 1>&2; \
1631           exit 1; \
1632         fi
1633 # Empty files or directories should not be distributed. They can cause
1634 # unnecessary warnings for packagers. Directories used by automake during
1635 # distcheck must be excluded.
1636         if find $(top_distdir) -empty -and -not \( \
1637             -path $(top_distdir)/_build -or \
1638             -path $(top_distdir)/_inst \) | grep .; then \
1639           echo "Found empty files or directories in final archive." 1>&2; \
1640           exit 1; \
1641         fi
1642         if test -n "$(BUILD_RELEASE)" && \
1643            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1644            echo "Found unreleased version in NEWS." >&2; \
1645            exit 1; \
1646         fi
1647
1648 # When building a release, stricter checks should be used
1649 distcheck-release dist-release: export BUILD_RELEASE = 1
1650 distcheck-release: distcheck
1651
1652 distrebuildcheck: dist
1653         set -e; \
1654         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1655         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1656         cd $$builddir; \
1657         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1658         cd $(distdir); \
1659         ./configure; \
1660         $(MAKE) maintainer-clean; \
1661         cp $(abs_srcdir)/vcs-version .; \
1662         ./configure; \
1663         $(MAKE) $(AM_MAKEFLAGS)
1664
1665 dist-release: dist
1666         set -e; \
1667         for i in $(DIST_ARCHIVES); do \
1668           echo -n "Checking $$i ... "; \
1669           autotools/check-tar < $$i; \
1670           echo OK; \
1671         done
1672
1673 install-exec-local:
1674         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1675           "$(DESTDIR)${localstatedir}/log/ganeti" \
1676           "$(DESTDIR)${localstatedir}/run/ganeti"
1677
1678 .PHONY: apidoc
1679 if WANT_HTOOLSAPIDOC
1680 apidoc: py-apidoc hs-apidoc
1681 else
1682 apidoc: py-apidoc
1683 endif
1684
1685 .PHONY: py-apidoc
1686 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1687         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1688         $(RUN_IN_TEMPDIR) epydoc -v \
1689           --conf $(CURDIR)/epydoc.conf \
1690           --output $(CURDIR)/$(APIDOC_PY_DIR)
1691
1692 .PHONY: hs-apidoc
1693 hs-apidoc: $(HS_BUILT_SRCS)
1694         @test -n "$(HSCOLOUR)" || \
1695             { echo 'HsColour' not found during configure; exit 1; }
1696         @test -n "$(HADDOCK)" || \
1697             { echo 'haddock' not found during configure; exit 1; }
1698         rm -rf $(APIDOC_HS_DIR)/*
1699         for i in $(ALL_APIDOC_HS_DIRS); do \
1700           @mkdir_p@ $$i; \
1701         done
1702         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1703         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1704         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1705         set -e ; \
1706         cd htools; \
1707         if [ "$(HTOOLS_NOCURL)" ]; \
1708         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1709         else OPTGHC=""; \
1710         fi; \
1711         if [ "$(HTOOLS_PARALLEL3)" ]; \
1712         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1713         fi; \
1714         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1715         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1716         fi; \
1717         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1718         for file in $$RELSRCS; do \
1719           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1720           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1721         done ; \
1722         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1723           -t ganeti -p haddock-prologue \
1724           --source-module="%{MODULE/.//}.html" \
1725           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1726           $$OPTGHC \
1727           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1728
1729 .PHONY: TAGS
1730 TAGS: $(GENERATED_FILES)
1731         rm -f TAGS
1732         $(GHC) -e ":etags" -v0 \
1733           $(filter-out -O -Werror,$(HFLAGS)) \
1734           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1735           $(HS_LIBTEST_SRCS)
1736         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1737           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1738           -path './qa/*.py' | \
1739           etags -l python -a -
1740
1741 .PHONY: coverage
1742 if WANT_HTOOLS
1743 coverage: py-coverage hs-coverage
1744 else
1745 coverage: py-coverage
1746 endif
1747
1748 .PHONY: py-coverage
1749 py-coverage: $(GENERATED_FILES) $(python_tests)
1750         @test -n "$(PYCOVERAGE)" || \
1751             { echo 'python-coverage' not found during configure; exit 1; }
1752         set -e; \
1753         COVERAGE=$(PYCOVERAGE) \
1754         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1755         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1756         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1757         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1758         $(python_tests)
1759
1760 .PHONY: hs-coverage
1761 hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
1762         rm -f *.tix
1763         $(MAKE) $(AM_MAKEFLAGS) hs-check
1764         @mkdir_p@ $(COVERAGE_HS_DIR)
1765         hpc sum --union $(HPCEXCL) \
1766           test.tix hpc-htools.tix hpc-mon-collector.tix > coverage-htools.tix
1767         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1768         hpc report coverage-htools.tix
1769         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1770
1771 # Special "kind-of-QA" target for htools, needs special setup (all
1772 # tools compiled with -fhpc)
1773 .PHONY: live-test
1774 live-test: all
1775         set -e ; \
1776         cd htools; \
1777         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1778         rm -f *.tix *.mix; \
1779         ./live-test.sh; \
1780         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1781           --output=live-test.tix ; \
1782         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1783         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1784           --srcdir=.. $(HPCEXCL) ; \
1785         hpc report --srcdir=.. live-test $(HPCEXCL)
1786
1787 commit-check: distcheck lint apidoc
1788
1789 .PHONY: gitignore-check
1790 gitignore-check:
1791         @if [ -n "`git status --short`" ]; then \
1792           echo "Git status is not clean!" 1>&2 ; \
1793           git status --short; \
1794           exit 1; \
1795         fi
1796
1797 # Target that builds all binaries (including those that are not
1798 # rebuilt except when running the tests)
1799 .PHONY: really-all
1800 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1801
1802 # we don't need the ancient implicit rules:
1803 %: %,v
1804 %: RCS/%,v
1805 %: RCS/%
1806 %: s.%
1807 %: SCCS/s.%
1808
1809 -include ./Makefile.local
1810
1811 # vim: set noet :